MANox
Mechanical
- Apr 2, 2007
- 130
Hello,
I need a litte help:
I add atributte ENDTYPE to BodyFeature:
And I can find this BodyFeature with:
And now I want add posibility fo change attribute by select this BodyFeature.
I try with:
and
(and many other combination), but I can't find solution.
Maybe somebody see where I wrong.
Best regards
MANok
TC14
NX2027
I need a litte help:
I add atributte ENDTYPE to BodyFeature:
Code:
Private Sub AddAttribute(nxObject2 As NXObject, endAttr As String, isSubstract As Boolean)
If isSubstract = False Then
Dim bodyFeature1 As NXOpen.Features.BodyFeature = CType(nxObject2, NXOpen.Features.BodyFeature)
Dim edges1() = bodyFeature1.GetEdges
Dim body1 As Body = edges1(0).GetBody
Dim feature1 As Features.Feature = body1.GetFeatures(0)
feature1.SetUserAttribute("EndType", -1, endAttr, Update.Option.Now)
End If
End Sub
And I can find this BodyFeature with:
Code:
For Each feature1 As Features.BodyFeature In Body1.GetFeatures
If feature1.FeatureType = "SIMPLE HOLE" Or feature1.FeatureType = "HOLE PACKAGE" Then
Dim exps() As Expression
Dim index2 As Integer = -1
exps = feature1.GetExpressions()
index2 = exps(0).Description.IndexOf("Threaded")
If index2 > 0 Then
If feature1.HasUserAttribute("ENDTYPE", NXObject.AttributeType.String, -1) Then
Dim attributeInfo As NXObject.AttributeInformation = feature1.GetUserAttribute("ENDTYPE", NXObject.AttributeType.String, 0)
lw.WriteLine(attributeInfo.StringValue)
Else
lw.WriteLine("no attributte")
End If
End If
End If
Next
And now I want add posibility fo change attribute by select this BodyFeature.
I try with:
Code:
Function SelectFeature(ByVal prompt As String, ByRef featureToReturn As NXObject) As Boolean
Dim theUI As UI = UI.GetUI
Dim title As String = prompt
Dim includeFeatures As Boolean = False
Dim keepHighlighted As Boolean = False
Dim selAction As Selection.SelectionAction = Selection.SelectionAction.ClearAndEnableSpecific
Dim cursor As Point3d
Dim scope As Selection.SelectionScope = Selection.SelectionScope.WorkPart
Dim selectionMask_array(0) As Selection.MaskTriple
Dim selObj1 As TaggedObject = Nothing
With selectionMask_array(0)
.Type = UFConstants.UF_feature_type
'.Subtype =
'.SolidBodySubtype = UFConstants.UF_dim_hole_subtype
End With
Dim resp As Selection.Response = theUI.SelectionManager.SelectTaggedObject(prompt, title, scope, selAction, includeFeatures, keepHighlighted, selectionMask_array, selObj1, cursor)
If resp = Selection.Response.ObjectSelected OrElse resp = Selection.Response.ObjectSelectedByName Then
Dim i As Integer = 0
featureToReturn = Utilities.NXObjectManager.Get(selObj1.Tag)
Return True
Else
featureToReturn = Nothing
Return False
End If
End Function
and
Code:
Do While SelectFeature("Select thread to edition", myFeature) = True
'MsgBox(myFeature.JournalIdentifier)
Dim myBodyFeature = CType(myFeature, BodyFeature)
If myBodyFeature.FeatureType = "SIMPLE HOLE" Or myBodyFeature.FeatureType = "HOLE PACKAGE" Then
Dim exps() As Expression
Dim index2 As Integer = -1
exps = myBodyFeature.GetExpressions()
index2 = exps(0).Description.IndexOf("Threaded")
If index2 > 0 Then
' MsgBox(myFeature.FeatureType)
If myBodyFeature.HasUserAttribute("ENDTYPE", NXObject.AttributeType.String, -1) Then
Dim attributeInfo As NXObject.AttributeInformation = myBodyFeature.GetUserAttribute("ENDTYPE", NXObject.AttributeType.String, 0)
MsgBox(attributeInfo.StringValue)
Else
MsgBox("Selected feature haven't attribute ENDTYPE. I'm so sorry bro (or sis)")
End If
Else
MsgBox("select thread, please...")
End If
End If
Loop
(and many other combination), but I can't find solution.
Maybe somebody see where I wrong.
Best regards
MANok
TC14
NX2027